/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/

#line 1 "cmdline.opt"
/* This file is part of Idest. -*- c -*-
   Copyright (C) 2009-2011, 2016-2017 Sergey Poznyakoff

   Idest is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   Idest is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Idest.  If not, see <http://www.gnu.org/licenses/>. */

static int mode_set = 0;
#define SET_MODE(m) do {                                                   \
		if (mode_set++ && mode != m)                               \
			error(1, 0, "only one of -q, -s, -d may be used"); \
		mode = m;                                                  \
	} while(0)

static unsigned
get_version_list(const char *arg)
{
	unsigned vers = 0;

	while (1) {
		switch (*arg) {
		case '1':
			vers |= IDEST_ID3V_1;
			break;
		case '2':
			vers |= IDEST_ID3V_2;
			break;
		default:
			error(1, 0, "invalid or unsupported version near %s",
			      arg);
		}
		if (*++arg == ',')
			++arg;
		else if (*arg == 0)
			break;
		else
			error(1, 0, "malformed version list near %s",
			      arg);
	}
	return vers;
}

#line 52 "cmdline.opt"

#line 52
void print_help(void);
#line 52
void print_usage(void);
#line 275 "cmdline.opt"

#line 275
/* Option codes */
#line 275
enum {
#line 275
	_OPTION_INIT=255,
#line 275
	#line 145 "cmdline.opt"

#line 145
	OPTION_CHARSET,	
#line 151 "cmdline.opt"

#line 151
	OPTION_BROKEN_8BIT_CHARSET,	
#line 173 "cmdline.opt"

#line 173
	OPTION_LATIN1,	
#line 193 "cmdline.opt"

#line 193
	OPTION_BACKUP,	
#line 203 "cmdline.opt"

#line 203
	OPTION_BACKUP_SUFFIX,	
#line 209 "cmdline.opt"

#line 209
	OPTION_BACKUP_DIRECTORY,	
#line 215 "cmdline.opt"

#line 215
#ifdef GUILE_VERSION
#line 215
	OPTION_TRACE,
#line 215
#endif	
#line 275 "cmdline.opt"

#line 275
	OPTION_USAGE,	
#line 275 "cmdline.opt"

#line 275
	OPTION_VERSION,	

#line 275 "cmdline.opt"
	MAX_OPTION
#line 275
};
#line 275
static struct option long_options[] = {
#line 275
	#line 58 "cmdline.opt"

#line 58
	{ "query", optional_argument, 0, 'q' },
#line 66 "cmdline.opt"

#line 66
	{ "all", no_argument, 0, 'a' },
#line 73 "cmdline.opt"

#line 73
	{ "set", required_argument, 0, 's' },
#line 86 "cmdline.opt"

#line 86
	{ "delete", optional_argument, 0, 'd' },
#line 94 "cmdline.opt"

#line 94
	{ "info", no_argument, 0, 'i' },
#line 100 "cmdline.opt"

#line 100
	{ "copy", required_argument, 0, 'c' },
#line 106 "cmdline.opt"

#line 106
	{ "list-frames", no_argument, 0, 'L' },
#line 112 "cmdline.opt"

#line 112
	{ "fixup", no_argument, 0, 'f' },
#line 121 "cmdline.opt"

#line 121
	{ "filter", required_argument, 0, 'F' },
#line 127 "cmdline.opt"

#line 127
	{ "id-version", required_argument, 0, 'V' },
#line 133 "cmdline.opt"

#line 133
	{ "default-id-version", required_argument, 0, 'U' },
#line 139 "cmdline.opt"

#line 139
	{ "convert", required_argument, 0, 'C' },
#line 145 "cmdline.opt"

#line 145
	{ "charset", required_argument, 0, OPTION_CHARSET },
#line 151 "cmdline.opt"

#line 151
	{ "broken-8bit-charset", required_argument, 0, OPTION_BROKEN_8BIT_CHARSET },
#line 157 "cmdline.opt"

#line 157
	{ "encoding", required_argument, 0, 'e' },
#line 173 "cmdline.opt"

#line 173
	{ "latin1", no_argument, 0, OPTION_LATIN1 },
#line 179 "cmdline.opt"

#line 179
	{ "verbose", no_argument, 0, 'v' },
#line 185 "cmdline.opt"

#line 185
	{ "describe", no_argument, 0, 'D' },
#line 193 "cmdline.opt"

#line 193
	{ "backup", optional_argument, 0, OPTION_BACKUP },
#line 203 "cmdline.opt"

#line 203
	{ "backup-suffix", required_argument, 0, OPTION_BACKUP_SUFFIX },
#line 209 "cmdline.opt"

#line 209
	{ "backup-directory", required_argument, 0, OPTION_BACKUP_DIRECTORY },
#line 215 "cmdline.opt"

#line 215
#ifdef GUILE_VERSION
#line 215
	{ "script", required_argument, 0, 'S' },
#line 215
#endif
#line 215 "cmdline.opt"

#line 215
#ifdef GUILE_VERSION
#line 215
	{ "format", required_argument, 0, 'H' },
#line 215
#endif
#line 215 "cmdline.opt"

#line 215
#ifdef GUILE_VERSION
#line 215
	{ "batch", required_argument, 0, 'B' },
#line 215
#endif
#line 215 "cmdline.opt"

#line 215
#ifdef GUILE_VERSION
#line 215
	{ "dry-run", no_argument, 0, 'n' },
#line 215
#endif
#line 215 "cmdline.opt"

#line 215
#ifdef GUILE_VERSION
#line 215
	{ "trace", optional_argument, 0, OPTION_TRACE },
#line 215
#endif
#line 215 "cmdline.opt"

#line 215
#ifdef GUILE_VERSION
#line 215
	{ "load-path", required_argument, 0, 'P' },
#line 215
#endif
#line 215 "cmdline.opt"

#line 215
#ifdef GUILE_VERSION
#line 215
	{ "prepend-load-path", required_argument, 0, 'p' },
#line 215
#endif
#line 215 "cmdline.opt"

#line 215
#ifdef GUILE_VERSION
#line 215
	{ "no-init-files", no_argument, 0, 'N' },
#line 215
#endif
#line 275 "cmdline.opt"

#line 275
	{ "help", no_argument, 0, 'h' },
#line 275 "cmdline.opt"

#line 275
	{ "usage", no_argument, 0, OPTION_USAGE },
#line 275 "cmdline.opt"

#line 275
	{ "version", no_argument, 0, OPTION_VERSION },

#line 275 "cmdline.opt"
	{0, 0, 0, 0}
#line 275
};
#line 275
static struct opthelp {
#line 275
        const char *opt;
#line 275
        const char *arg;
#line 275
        int is_optional;
#line 275
        const char *descr;
#line 275
} opthelp[] = {
#line 275
	#line 56 "cmdline.opt"

#line 56
	{ NULL, NULL, 0, N_("Operation mode") },	
#line 60 "cmdline.opt"

#line 60
	{ "-q, --query", N_("FLIST"), 1, N_("query mode") },
#line 68 "cmdline.opt"

#line 68
	{ "-a, --all", NULL, 0, N_("query all frames") },
#line 75 "cmdline.opt"

#line 75
	{ "-s, --set", N_("FIELD=VALUE"), 0, N_("set FIELD to VALUE") },
#line 88 "cmdline.opt"

#line 88
	{ "-d, --delete", N_("FLIST"), 1, N_("delete ID3 tags") },
#line 96 "cmdline.opt"

#line 96
	{ "-i, --info", NULL, 0, N_("display information about ID3 tags") },
#line 102 "cmdline.opt"

#line 102
	{ "-c, --copy", N_("FILE"), 0, N_("copy frames from FILE") },
#line 108 "cmdline.opt"

#line 108
	{ "-L, --list-frames", NULL, 0, N_("list all supported frames") },
#line 114 "cmdline.opt"

#line 114
	{ "-f, --fixup", NULL, 0, N_("fixup ID3 tags") },
#line 119 "cmdline.opt"

#line 119
	{ NULL, NULL, 0, N_("Operation modifiers") },	
#line 123 "cmdline.opt"

#line 123
	{ "-F, --filter", N_("FRAME-LIST"), 0, N_("operate only on matching frames") },
#line 129 "cmdline.opt"

#line 129
	{ "-V, --id-version", N_("VERSION"), 0, N_("write new and changed tags in the given ID3 version") },
#line 135 "cmdline.opt"

#line 135
	{ "-U, --default-id-version", N_("VERSION"), 0, N_("create new tags in the given ID3 version") },
#line 141 "cmdline.opt"

#line 141
	{ "-C, --convert", N_("VERSION"), 0, N_("convert tags to VERSION") },
#line 147 "cmdline.opt"

#line 147
	{ "--charset", N_("CODE"), 0, N_("use this charset for external representation") },
#line 153 "cmdline.opt"

#line 153
	{ "--broken-8bit-charset", N_("CODE"), 0, N_("assume textual frames in this 8bit charset") },
#line 159 "cmdline.opt"

#line 159
	{ "-e, --encoding", N_("NAME"), 0, N_("set encoding for textual tags") },
#line 175 "cmdline.opt"

#line 175
	{ "--latin1", NULL, 0, N_("same as --encoding=latin1") },
#line 181 "cmdline.opt"

#line 181
	{ "-v, --verbose", NULL, 0, N_("verbosely list files processed") },
#line 187 "cmdline.opt"

#line 187
	{ "-D, --describe", NULL, 0, N_("print verbose frame descriptions instead of short names") },
#line 191 "cmdline.opt"

#line 191
	{ NULL, NULL, 0, N_("Backup options") },	
#line 195 "cmdline.opt"

#line 195
	{ "--backup", N_("CONTROL"), 1, N_("backup before modifying, choose version CONTROL") },
#line 205 "cmdline.opt"

#line 205
	{ "--backup-suffix", N_("SUF"), 0, N_("set backup suffix, instead of the default ~") },
#line 211 "cmdline.opt"

#line 211
	{ "--backup-directory", N_("DIR"), 0, N_("backup to given DIR") },
#line 215 "cmdline.opt"

#line 215
#ifdef GUILE_VERSION
#line 215
	{ NULL, NULL, 0, N_("Scripting options") },
#line 215
#endif	
#line 215 "cmdline.opt"

#line 215
#ifdef GUILE_VERSION
#line 215
	{ "-S, --script", N_("FILE"), 0, N_("read Guile script from FILE; this stops further argument processing") },
#line 215
#endif
#line 215 "cmdline.opt"

#line 215
#ifdef GUILE_VERSION
#line 215
	{ "-H, --format", N_("NAME"), 0, N_("apply external format NAME; this stops further argument processing") },
#line 215
#endif
#line 215 "cmdline.opt"

#line 215
#ifdef GUILE_VERSION
#line 215
	{ "-B, --batch", N_("NAME"), 0, N_("apply batch modification module NAME; this stops further argument processing") },
#line 215
#endif
#line 215 "cmdline.opt"

#line 215
#ifdef GUILE_VERSION
#line 215
	{ "-n, --dry-run", NULL, 0, N_("run the script, print modified frames but do not write them to the file") },
#line 215
#endif
#line 215 "cmdline.opt"

#line 215
#ifdef GUILE_VERSION
#line 215
	{ "--trace", N_("LEVEL"), 1, N_("start with debugging evaluator and backtraces") },
#line 215
#endif
#line 215 "cmdline.opt"

#line 215
#ifdef GUILE_VERSION
#line 215
	{ "-P, --load-path", N_("PATH"), 0, N_("append PATH to the load path") },
#line 215
#endif
#line 215 "cmdline.opt"

#line 215
#ifdef GUILE_VERSION
#line 215
	{ "-p, --prepend-load-path", N_("PATH"), 0, N_("prepend PATH to the load path") },
#line 215
#endif
#line 215 "cmdline.opt"

#line 215
#ifdef GUILE_VERSION
#line 215
	{ "-N, --no-init-files", NULL, 0, N_("do not load Scheme init files") },
#line 215
#endif
#line 275 "cmdline.opt"

#line 275
	{ NULL, NULL, 0, N_("Other options") },	
#line 275 "cmdline.opt"

#line 275
	{ "-h, --help", NULL, 0, N_("Give this help list") },
#line 275 "cmdline.opt"

#line 275
	{ "--usage", NULL, 0, N_("Give a short usage message") },
#line 275 "cmdline.opt"

#line 275
	{ "--version", NULL, 0, N_("Print program version") },

#line 275 "cmdline.opt"
};
#line 52 "cmdline.opt"

#line 52
#include <ctype.h>
#line 52
const char *program_version = "idest" " (" PACKAGE_NAME ") " PACKAGE_VERSION;
#line 52
static char doc[] = N_("idest - ID3 Edit and Scripting Tool");
#line 52
static char args_doc[] = N_("FILE [FILE...]");
#line 52
const char *program_bug_address = "<" PACKAGE_BUGREPORT ">";
#line 52
		    
#line 52
#define DESCRCOLUMN 30
#line 52
#define RMARGIN 79
#line 52
#define GROUPCOLUMN 2
#line 52
#define USAGECOLUMN 13
#line 52
		    
#line 52
static void
#line 52
indent (size_t start, size_t col)
#line 52
{
#line 52
  for (; start < col; start++)
#line 52
    putchar (' ');
#line 52
}
#line 52
		    
#line 52
static void
#line 52
print_option_descr (const char *descr, size_t lmargin, size_t rmargin)
#line 52
{
#line 52
  while (*descr)
#line 52
    {
#line 52
      size_t s = 0;
#line 52
      size_t i;
#line 52
      size_t width = rmargin - lmargin;
#line 52

#line 52
      for (i = 0; ; i++)
#line 52
	{
#line 52
	  if (descr[i] == 0 || isspace (descr[i]))
#line 52
	    {
#line 52
	      if (i > width)
#line 52
		break;
#line 52
	      s = i;
#line 52
	      if (descr[i] == 0)
#line 52
		break;
#line 52
	    }
#line 52
	}
#line 52
      printf ("%*.*s\n", s, s, descr);
#line 52
      descr += s;
#line 52
      if (*descr)
#line 52
	{
#line 52
	  indent (0, lmargin);
#line 52
	  descr++;
#line 52
	}
#line 52
    }
#line 52
}
#line 52

#line 52
void
#line 52
print_help(void)
#line 52
{
#line 52
  unsigned i;
#line 52
  
#line 52
  printf ("%s %s [%s]... %s\n", _("Usage:"), "idest", _("OPTION"),
#line 52
	  gettext (args_doc)); 
#line 52
  if (doc[0])
#line 52
    print_option_descr(gettext (doc), 0, RMARGIN);
#line 52
  putchar ('\n');
#line 52

#line 52
  for (i = 0; i < sizeof (opthelp) / sizeof (opthelp[0]); i++)
#line 52
    {
#line 52
      unsigned n;
#line 52
      if (opthelp[i].opt)
#line 52
	{
#line 52
	  n = printf ("  %s", opthelp[i].opt);
#line 52
	  if (opthelp[i].arg)
#line 52
	    {
#line 52
	      char *cb, *ce, *sep = "";
#line 52
	      if (opthelp[i].is_optional)
#line 52
		{
#line 52
		  cb = "[";
#line 52
		  ce = "]";
#line 52
		}
#line 52
	      else
#line 52
		cb = ce = "";
#line 52

#line 52
              if (strlen (opthelp[i].opt) == 2)
#line 52
                {
#line 52
                  if (!opthelp[i].is_optional)
#line 52
                    sep = " ";
#line 52
                }
#line 52
              else
#line 52
                sep = "=";
#line 52
	      n += printf ("%s%s%s%s", cb, sep, gettext (opthelp[i].arg), ce);
#line 52
	    }
#line 52
	  if (n >= DESCRCOLUMN)
#line 52
	    {
#line 52
	      putchar ('\n');
#line 52
	      n = 0;
#line 52
	    }
#line 52
	  indent (n, DESCRCOLUMN);
#line 52
	  print_option_descr (gettext (opthelp[i].descr), DESCRCOLUMN, RMARGIN);
#line 52
	}
#line 52
      else
#line 52
	{
#line 52
	  if (i)
#line 52
	    putchar ('\n');
#line 52
	  indent (0, GROUPCOLUMN);
#line 52
	  print_option_descr (gettext (opthelp[i].descr),
#line 52
			      GROUPCOLUMN, RMARGIN);
#line 52
	  putchar ('\n');
#line 52
	}
#line 52
    }
#line 52
  
#line 52
  putchar ('\n');
#line 52
  print_option_descr (_("Mandatory or optional arguments to long options are also mandatory or optional for any corresponding short options."), 0, RMARGIN);
#line 52
  putchar ('\n');
#line 52
  printf (_("Report bugs to %s.\n"), program_bug_address);
#line 52
}
#line 52

#line 52
void
#line 52
print_usage(void)
#line 52
{
#line 52
  unsigned i;
#line 52
  int f = 0;
#line 52
  unsigned n;
#line 52
  char buf[RMARGIN+1];
#line 52

#line 52
#define FLUSH                        do                                   {                              	  buf[n] = 0;              	  printf ("%s\n", buf);    	  n = USAGECOLUMN;         	  memset (buf, ' ', n);        }                                while (0)
#line 52
#define ADDC(c)   do { if (n == RMARGIN) FLUSH; buf[n++] = c; } while (0)
#line 52

#line 52
  n = snprintf (buf, sizeof buf, "%s %s ", _("Usage:"), "idest");
#line 52

#line 52
  /* Print a list of short options without arguments. */
#line 52
  for (i = 0; i < sizeof (opthelp) / sizeof (opthelp[0]); i++)
#line 52
    {
#line 52
      if (opthelp[i].opt && opthelp[i].descr && opthelp[i].opt[1] != '-'
#line 52
	  && opthelp[i].arg == NULL)
#line 52
	{
#line 52
	  if (f == 0)
#line 52
	    {
#line 52
	      ADDC('[');
#line 52
	      ADDC('-');
#line 52
	      f = 1;
#line 52
	    }
#line 52
	  ADDC(opthelp[i].opt[1]);
#line 52
	}
#line 52
    }
#line 52
  if (f)
#line 52
    ADDC(']');
#line 52

#line 52
  /* Print a list of short options with arguments. */
#line 52
  for (i = 0; i < sizeof (opthelp) / sizeof (opthelp[0]); i++)
#line 52
    {
#line 52
      if (opthelp[i].opt && opthelp[i].descr && opthelp[i].opt[1] != '-'
#line 52
	  && opthelp[i].arg)
#line 52
	{
#line 52
	  size_t len = 5 
#line 52
	                + strlen (opthelp[i].arg)
#line 52
			   + (opthelp[i].is_optional ? 2 : 1);
#line 52
	  if (n + len > RMARGIN) FLUSH;
#line 52
	  buf[n++] = ' '; 
#line 52
	  buf[n++] = '['; 
#line 52
	  buf[n++] = '-';
#line 52
	  buf[n++] = opthelp[i].opt[1];
#line 52
	  if (opthelp[i].is_optional)
#line 52
	    {
#line 52
	      buf[n++] = '[';
#line 52
	      strcpy (&buf[n], opthelp[i].arg);
#line 52
	      n += strlen (opthelp[i].arg);
#line 52
	      buf[n++] = ']';
#line 52
	    }
#line 52
	  else
#line 52
	    {
#line 52
	      buf[n++] = ' ';
#line 52
	      strcpy (&buf[n], opthelp[i].arg);
#line 52
	      n += strlen (opthelp[i].arg);
#line 52
	    }
#line 52
	  buf[n++] = ']';
#line 52
	}
#line 52
    }
#line 52

#line 52
  /* Print a list of long options */
#line 52
  for (i = 0; i < sizeof (opthelp) / sizeof (opthelp[0]); i++)
#line 52
    {
#line 52
      if (opthelp[i].opt && opthelp[i].descr)
#line 52
	{
#line 52
	  size_t len;
#line 52
	  const char *longopt;
#line 52

#line 52
	  if (opthelp[i].opt[1] == '-')
#line 52
	    longopt = opthelp[i].opt;
#line 52
	  else if (opthelp[i].opt[2] == ',')
#line 52
	    longopt = opthelp[i].opt + 4;
#line 52
	  else
#line 52
	    continue;
#line 52

#line 52
	  len = 3 + strlen (longopt)
#line 52
	          + (opthelp[i].arg ? 1 + strlen (opthelp[i].arg)
#line 52
		      + (opthelp[i].is_optional ? 2 : 0) : 0);
#line 52
	  if (n + len > RMARGIN) FLUSH;
#line 52
	  buf[n++] = ' '; 
#line 52
	  buf[n++] = '['; 
#line 52
	  strcpy (&buf[n], longopt);
#line 52
	  n += strlen (longopt);
#line 52
	  if (opthelp[i].arg)
#line 52
	    {
#line 52
	      buf[n++] = '=';
#line 52
	      if (opthelp[i].is_optional)
#line 52
		{
#line 52
		  buf[n++] = '[';
#line 52
		  strcpy (&buf[n], opthelp[i].arg);
#line 52
		  n += strlen (opthelp[i].arg);
#line 52
		  buf[n++] = ']';
#line 52
		}
#line 52
	      else
#line 52
		{
#line 52
		  strcpy (&buf[n], opthelp[i].arg);
#line 52
		  n += strlen (opthelp[i].arg);
#line 52
		}
#line 52
	    }
#line 52
	  buf[n++] = ']';
#line 52
	}
#line 52
    }
#line 52
  FLUSH;
#line 52
  
#line 52
}
#line 52

#line 52
const char version_etc_copyright[] =
#line 52
  /* Do *not* mark this string for translation.  %s is a copyright
     symbol suitable for this locale, and %d is the copyright
     year.  */
#line 52
  "Copyright %s 2005-2011, 2015 Sergey Poznyakoff";
#line 52

#line 52
void
#line 52
print_version_only(const char *program_version, FILE *stream)
#line 52
{
#line 52
	fprintf (stream, "%s\n", program_version);
#line 52
	/* TRANSLATORS: Translate "(C)" to the copyright symbol
	   (C-in-a-circle), if this symbol is available in the user's
	   locale.  Otherwise, do not translate "(C)"; leave it as-is.  */
#line 52
	fprintf (stream, version_etc_copyright, _("(C)"));
#line 52
	fputc ('\n', stream);
#line 52
}
#line 52

#line 52
void
#line 52
print_version(const char *program_version, FILE *stream)
#line 52
{
#line 52
	print_version_only(program_version, stream);
#line 52
	
#line 52
	fputs (_("License GPLv3+: GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>\nThis is free software: you are free to change and redistribute it.\nThere is NO WARRANTY, to the extent permitted by law.\n\n"),
#line 52
	       stream);
#line 52
	
#line 52
}
#line 52

#line 275 "cmdline.opt"

#line 275


void
get_options(int argc, char *argv[])
{
	
#line 280
 {
#line 280
  int c;
#line 280
  int stop = 0;
#line 280

#line 280
  while (!stop && (c = getopt_long(argc, argv, 
#line 280
"q::"
#line 280
"a"
#line 280
"s:"
#line 280
"d::"
#line 280
"i"
#line 280
"c:"
#line 280
"L"
#line 280
"f"
#line 280
"F:"
#line 280
"V:"
#line 280
"U:"
#line 280
"C:"
#line 280
"e:"
#line 280
"v"
#line 280
"D"
#line 280
#ifdef GUILE_VERSION
#line 280
"S:"
#line 280
#endif
#line 280

#line 280
#ifdef GUILE_VERSION
#line 280
"H:"
#line 280
#endif
#line 280

#line 280
#ifdef GUILE_VERSION
#line 280
"B:"
#line 280
#endif
#line 280

#line 280
#ifdef GUILE_VERSION
#line 280
"n"
#line 280
#endif
#line 280

#line 280
#ifdef GUILE_VERSION
#line 280
"P:"
#line 280
#endif
#line 280

#line 280
#ifdef GUILE_VERSION
#line 280
"p:"
#line 280
#endif
#line 280

#line 280
#ifdef GUILE_VERSION
#line 280
"N"
#line 280
#endif
#line 280

#line 280
"h",
#line 280
			           long_options, NULL)) != EOF)
#line 280
    {
#line 280
      switch (c)
#line 280
        {
#line 280
        default:
#line 280
	exit(1);
#line 280
       
#line 280
	#line 60 "cmdline.opt"

#line 60
	 case 'q':
#line 60
          {
#line 60

	SET_MODE(MODE_QUERY);
	if (optarg)
		parse_filter_items(optarg);

#line 64
             break;
#line 64
          }
#line 68 "cmdline.opt"

#line 68
	 case 'a':
#line 68
          {
#line 68

       SET_MODE(MODE_QUERY);
       all_frames = 1;

#line 71
             break;
#line 71
          }
#line 75 "cmdline.opt"

#line 75
	 case 's':
#line 75
          {
#line 75

       char *p;

       SET_MODE(MODE_MOD);
       p = strchr(optarg, '=');
       if (!p)
	       error(1, 0, "missing `=' sign in assignment");
       *p++ = 0;
       input_list_add_assignment(optarg, p);

#line 84
             break;
#line 84
          }
#line 88 "cmdline.opt"

#line 88
	 case 'd':
#line 88
          {
#line 88

	SET_MODE(MODE_DELETE);
	if (optarg)
		parse_filter_items(optarg);

#line 92
             break;
#line 92
          }
#line 96 "cmdline.opt"

#line 96
	 case 'i':
#line 96
          {
#line 96

	SET_MODE(MODE_INFO);

#line 98
             break;
#line 98
          }
#line 102 "cmdline.opt"

#line 102
	 case 'c':
#line 102
          {
#line 102

	source_file = optarg;

#line 104
             break;
#line 104
          }
#line 108 "cmdline.opt"

#line 108
	 case 'L':
#line 108
          {
#line 108

	SET_MODE(MODE_LIST);

#line 110
             break;
#line 110
          }
#line 114 "cmdline.opt"

#line 114
	 case 'f':
#line 114
          {
#line 114

	fixup_option = 1;
	SET_MODE(MODE_MOD);

#line 117
             break;
#line 117
          }
#line 123 "cmdline.opt"

#line 123
	 case 'F':
#line 123
          {
#line 123

	parse_filter_items(optarg);

#line 125
             break;
#line 125
          }
#line 129 "cmdline.opt"

#line 129
	 case 'V':
#line 129
          {
#line 129

	version_option = get_version_list(optarg);

#line 131
             break;
#line 131
          }
#line 135 "cmdline.opt"

#line 135
	 case 'U':
#line 135
          {
#line 135

	default_version_option = get_version_list(optarg);

#line 137
             break;
#line 137
          }
#line 141 "cmdline.opt"

#line 141
	 case 'C':
#line 141
          {
#line 141

	convert_version = get_version_list(optarg);

#line 143
             break;
#line 143
          }
#line 147 "cmdline.opt"

#line 147
	 case OPTION_CHARSET:
#line 147
          {
#line 147

	charset = optarg;

#line 149
             break;
#line 149
          }
#line 153 "cmdline.opt"

#line 153
	 case OPTION_BROKEN_8BIT_CHARSET:
#line 153
          {
#line 153

       broken_8bit_charset = optarg;

#line 155
             break;
#line 155
          }
#line 159 "cmdline.opt"

#line 159
	 case 'e':
#line 159
          {
#line 159

	if (strcasecmp(optarg, "latin1") == 0
	    || strcasecmp(optarg, "iso-8859-1") == 0)
		textual_frame_encoding = ID3_FIELD_TEXTENCODING_ISO_8859_1;
        else if (strcasecmp(optarg, "utf-16") == 0)
		textual_frame_encoding = ID3_FIELD_TEXTENCODING_UTF_16;
        else if (strcasecmp(optarg, "utf-16be") == 0)
		textual_frame_encoding = ID3_FIELD_TEXTENCODING_UTF_16BE;
	else if (strcasecmp(optarg, "utf-8") == 0)
		textual_frame_encoding = ID3_FIELD_TEXTENCODING_UTF_8;
        else
		error(1, 0, _("unsupported ID3 frame encoding"));

#line 171
             break;
#line 171
          }
#line 175 "cmdline.opt"

#line 175
	 case OPTION_LATIN1:
#line 175
          {
#line 175

	charset = "iso-8859-1";

#line 177
             break;
#line 177
          }
#line 181 "cmdline.opt"

#line 181
	 case 'v':
#line 181
          {
#line 181

	verbose_option = 1;

#line 183
             break;
#line 183
          }
#line 187 "cmdline.opt"

#line 187
	 case 'D':
#line 187
          {
#line 187

	describe_option = 1;

#line 189
             break;
#line 189
          }
#line 195 "cmdline.opt"

#line 195
	 case OPTION_BACKUP:
#line 195
          {
#line 195

       if (optarg)
		backup_type = xget_version ("--backup", optarg);
       else
		backup_type = xget_version ("VERSION_CONTROL",
					    getenv("VERSION_CONTROL"));

#line 201
             break;
#line 201
          }
#line 205 "cmdline.opt"

#line 205
	 case OPTION_BACKUP_SUFFIX:
#line 205
          {
#line 205

       simple_backup_suffix = optarg;

#line 207
             break;
#line 207
          }
#line 211 "cmdline.opt"

#line 211
	 case OPTION_BACKUP_DIRECTORY:
#line 211
          {
#line 211

       backup_dir = optarg;

#line 213
             break;
#line 213
          }
#line 215 "cmdline.opt"

#line 215
#ifdef GUILE_VERSION
#line 215
	 case 'S':
#line 215
          {
#line 215

#line 215
       set_guile_argv(argc - optind, argv + optind); /* Save rest of arguments */
#line 215
       *--guile_argv = optarg;
#line 215
       optind = argc; /* Stop argument processing */
#line 215

#line 215
             break;
#line 215
          }
#line 215
#endif
#line 215 "cmdline.opt"

#line 215
#ifdef GUILE_VERSION
#line 215
	 case 'H':
#line 215
          {
#line 215

#line 215
       format_name = optarg;
#line 215
       stop = 1; /* Stop argument processing */
#line 215

#line 215
             break;
#line 215
          }
#line 215
#endif
#line 215 "cmdline.opt"

#line 215
#ifdef GUILE_VERSION
#line 215
	 case 'B':
#line 215
          {
#line 215

#line 215
       batch_name = optarg;
#line 215
       stop = 1; /* Stop argument processing */
#line 215

#line 215
             break;
#line 215
          }
#line 215
#endif
#line 215 "cmdline.opt"

#line 215
#ifdef GUILE_VERSION
#line 215
	 case 'n':
#line 215
          {
#line 215

#line 215
       dry_run_option = 1;
#line 215

#line 215
             break;
#line 215
          }
#line 215
#endif
#line 215 "cmdline.opt"

#line 215
#ifdef GUILE_VERSION
#line 215
	 case OPTION_TRACE:
#line 215
          {
#line 215

#line 215
       if (optarg)
#line 215
	       guile_debug = atoi(optarg);
#line 215
       else
#line 215
	       guile_debug = 1;
#line 215

#line 215
             break;
#line 215
          }
#line 215
#endif
#line 215 "cmdline.opt"

#line 215
#ifdef GUILE_VERSION
#line 215
	 case 'P':
#line 215
          {
#line 215

#line 215
       guile_add_load_path(optarg, 1);
#line 215

#line 215
             break;
#line 215
          }
#line 215
#endif
#line 215 "cmdline.opt"

#line 215
#ifdef GUILE_VERSION
#line 215
	 case 'p':
#line 215
          {
#line 215

#line 215
       guile_add_load_path(optarg, 0);
#line 215

#line 215
             break;
#line 215
          }
#line 215
#endif
#line 215 "cmdline.opt"

#line 215
#ifdef GUILE_VERSION
#line 215
	 case 'N':
#line 215
          {
#line 215

#line 215
       no_init_files_option = 1;
#line 215

#line 215
             break;
#line 215
          }
#line 215
#endif
#line 275 "cmdline.opt"

#line 275
	 case 'h':
#line 275
          {
#line 275

#line 275
		print_help ();
#line 275
                exit (0);
#line 275
	 
#line 275
             break;
#line 275
          }
#line 275 "cmdline.opt"

#line 275
	 case OPTION_USAGE:
#line 275
          {
#line 275

#line 275
		print_usage ();
#line 275
		exit (0);
#line 275
	 
#line 275
             break;
#line 275
          }
#line 275 "cmdline.opt"

#line 275
	 case OPTION_VERSION:
#line 275
          {
#line 275

#line 275
		/* Give version */
#line 275
		print_version(program_version, stdout);
#line 275
		exit (0);
#line 275
         
#line 275
             break;
#line 275
          }

#line 280 "cmdline.opt"
        }
#line 280
    }
#line 280
 }   
#line 280

	if (optind < argc && mode == MODE_MOD) {
		char *p;
		/* See if we've been given any assignment arguments */
		while (argv[optind] && (p = strchr(argv[optind], '='))) {
			*p++ = 0;
			input_list_add_assignment(argv[optind++], p);
		}
	}
}
